
using Plots
using CSV, Glob, DataFrames,XLSX
using Statistics
using LinearAlgebra
using Statistics
using MultivariateStats
using DataFrames
using CategoricalArrays
using LIBSVM
using StatsBase

dir = "{Directory Automated Data}"
Rep = 1
minMass = 0
minInt = 0

    #Extract files and their names
        files = glob( "*.csv", dir)
        global tempdfs = DataFrame.(CSV.File.(files))
        global namest = []
        for i in 1:length(tempdfs)
            append!(namest, [files[i][64:end-15]])
        end
    #Delete blank rows from the CSV files
        for i in 1:length(tempdfs)
            nums = []
            lookfor = Matrix(tempdfs[i][!, names(tempdfs[i], " Max. MW")])
            for z in 1:length(lookfor)
                if lookfor[z] == String7(" ")
                    append!(nums, z)
                end
            end
            k = 0
            for l in 1:length(nums)
                global tempdfs[i] = delete!(tempdfs[i], nums[l]-k)
                k = k +1
            end
        end

    #obtain rt windows 
        for i in 1:length(tempdfs)
            tempdfs[i] = hcat(tempdfs[i], zeros(size(tempdfs[i])[1]))
            rename!(tempdfs[i], Dict(:x1 => "rt_min"))
            tempdfs[i] = hcat(tempdfs[i], zeros(size(tempdfs[i])[1]))
            rename!(tempdfs[i], Dict(:x1 => "rt_max"))
            tempdfs[i][:,8] = tempdfs[i][:,2].- tempdfs[i][:,4]*(3/2.355)
            tempdfs[i][:,9] = tempdfs[i][:,2].+ tempdfs[i][:,4]*(3/2.355)
        end



    #Extract masses and m/z values from the CSvs

        Masses = []
        for i in 1:length(tempdfs)
            append!(Masses, tempdfs[i][:,5])
        end

        conversion = []
        for i in 1:length(tempdfs)
            append!(conversion, tempdfs[i][:,7])
        end



        This = zeros(length(Masses),2)
        namesMyprot = string.(Masses)
        for i in 1:length(namesMyprot)
            if namesMyprot[i] == " "
                namesMyprot[i] = "0.0"
            end
        end

        for i in 1:length(namesMyprot)
            this = split(namesMyprot[i], ".")[1]
            num =  parse(Int,this)
            that = split(namesMyprot[i], ".")[2]
            dec = parse(Int,that)

            This[i,1] = num
            This[i,2] = dec/10000
        end

        FinalMasses = This[:,1] .+ This[:,2]


        Thismz = zeros(length(conversion),2)
        namesMyprot1 = string.(conversion)
        for i in 1:length(namesMyprot1)
            if namesMyprot1[i] == " "
                namesMyprot1[i] = "0.0"
            end
        end

        for i in 1:length(namesMyprot1)
            this = split(namesMyprot1[i], ".")[1]
            num =  parse(Int,this)
            that = split(namesMyprot1[i], ".")[2]
            dec = parse(Int,that)

            This[i,1] = num
            This[i,2] = dec/10000
        end

    #Group masses and mz values, maintaining the sample they came from
        Finalmz = This[:,1] .+ This[:,2]

        j = hcat(FinalMasses, Finalmz)

        MassesCluster = [Vector{Float64}(undef,1) for _ in 1:length(tempdfs)]
        Class1 = [Vector{Float64}(undef,1) for _ in 1:length(tempdfs)]
        mzCluster =  [Vector{Float64}(undef,1) for _ in 1:length(tempdfs)]
        z = 1
        for i in 1:length(tempdfs)
            MassesCluster[i] = FinalMasses[z:length(tempdfs[i][:,1])+z-1]
            Class1[i] = 0*FinalMasses[z:length(tempdfs[i][:,1])+z-1].+1*i
            mzCluster[i] = Finalmz[z:length(tempdfs[i][:,1])+z-1]
            z = z + length(tempdfs[i][:,1])


        end

        All1 = reduce(vcat,transpose.(MassesCluster'))
        Class= reduce(vcat,transpose.(Class1'))
        mzCluster = reduce(vcat,transpose.(mzCluster'))
        All2 = hcat(All1, Class, mzCluster)








        order = sortperm(All1)

        Allthree = hcat(permute!(All2[:,1], order), permute!(All2[:,2], order), permute!(All2[:,3], order))



        ord = sortperm(Allthree[:,2])
        for i in 1:3
            Allthree[:,i] = permute!(Allthree[:,i], ord)
         end
        Finallist = Allthree

    #Group masses and mz values, maintaining the sample they came from and the position within the sample the specific protein is

        Finaldf = [[0.0],[0],[0], [0.0]]

        for i in 1:length(Finallist[:,1])
            for z in 1:length(MassesCluster)
                for l in 1:length(MassesCluster[z])
                    if Finallist[i,2] == z
                        if Finallist[i,1] == MassesCluster[z][l] # && l > last(Finaldf[3])
                            append!(Finaldf[1], Finallist[i,1])
                            append!(Finaldf[2], z)
                            append!(Finaldf[3], l)
                            append!(Finaldf[4], Finallist[i,3])
                            MassesCluster[z][l] = 0
                            break
                        end
                    end
                end
            end
        end

        Finaldf[1] = Finaldf[1][2:length(Finaldf[1])]
        Finaldf[2] = Finaldf[2][2:length(Finaldf[2])]
        Finaldf[3] = Finaldf[3][2:length(Finaldf[3])]
        Finaldf[4] = Finaldf[4][2:length(Finaldf[4])]
        Finaldf = hcat(Finaldf[1],Finaldf[2],Finaldf[3], Finaldf[4])

        order1 = sortperm(Finaldf[:,1])

        FFinaldf = deepcopy(Finaldf)
        for i in 1:length(Finaldf[1,:])
            FFinaldf[:,i] = permute!(Finaldf[:,i], order1)
        end

        FFinaldf1 = append!(FFinaldf[:,1], 0)
        FFinaldf2 = append!(FFinaldf[:,2], 0)
        FFinaldf3 = append!(FFinaldf[:,3], 0)
        FFinaldf4 = append!(FFinaldf[:,4], 0)
        FFinaldf = reduce(hcat, (FFinaldf1, FFinaldf2, FFinaldf3, FFinaldf4))


#Flter protein masses and m/z values if theyre too similar within the same sample

        #Order by m/z, filter if m/z and mass are too similar


        finalproteins = [[] for i=1:length(tempdfs)]
        finalproteinsred = [Array{Float64}(undef,0,0) for i=1:Int64(length(tempdfs))]
        for i in 1:size(FFinaldf)[1]-1
            append!(finalproteins[Int64(FFinaldf[i,2])], [FFinaldf[i,:]])
        end

        for i in 1:length(finalproteins)
            finalproteinsred[i] = reduce(vcat, transpose(finalproteins[i]))
        end

        finalproteins1 = [[] for i=1:length(tempdfs)]
        finalproteinsred1 = [Array{Float64}(undef,0,0) for i=1:Int64(length(tempdfs))]

        for ii in 1:length(tempdfs)
            order = sortperm(finalproteinsred[ii][:,4])
            for i in 1:size(finalproteinsred[ii])[2]
                finalproteinsred[ii][:,i] = permute!(finalproteinsred[ii][:,i], order)
            end

            for i in 1:size(finalproteinsred[ii])[1]-1
                if finalproteinsred[ii][i+1,4] - finalproteinsred[ii][i,4] < 1.5 
                    finalproteinsred[ii][i+1,4] = finalproteinsred[ii][i,4]
                end
            end

            finalproteinsred[ii] = hcat(finalproteinsred[ii], zeros(size(finalproteins[ii])[1]))

            for i in 1:size(finalproteinsred[ii])[1]
                finalproteinsred[ii][i,5] = tempdfs[ii][Int64(finalproteinsred[ii][i,3]),3]
            end

            order = sortperm(finalproteinsred[ii][:,5])
            for i in 1:size(finalproteinsred[ii])[2]
                finalproteinsred[ii][:,i] = permute!(finalproteinsred[ii][:,i], order)
            end

            order = sortperm(finalproteinsred[ii][:,4])
            for i in 1:size(finalproteinsred[ii])[2]
                finalproteinsred[ii][:,i] = permute!(finalproteinsred[ii][:,i], order)
            end

            finalproteinsred[ii] = finalproteinsred[ii][:, 1:end-1]
            finalproteinsred[ii] = vcat(finalproteinsred[ii], [0.0,0.0, 0.0,1000000]')
            for i in 1:size(finalproteinsred[ii])[1]-1
                if finalproteinsred[ii][i+1,4] - finalproteinsred[ii][i,4] < 1.5
                    @goto label
                else
                    append!(finalproteins1[ii], [(finalproteinsred[ii][i,:])])
                    @label label
                end
            end

            finalproteinsred1[ii] = reduce(vcat, transpose(finalproteins1[ii]))

        end

            #order and filter by mass similarities

        finalproteins2 = [[] for i=1:length(tempdfs)]
        finalproteinsred2 = [Array{Float64}(undef,0,0) for i=1:Int64(length(tempdfs))]

        for ii in 1:length(tempdfs)
            order = sortperm(finalproteinsred1[ii][:,1])
            for i in 1:size(finalproteinsred1[ii])[2]
                finalproteinsred1[ii][:,i] = permute!(finalproteinsred1[ii][:,i], order)
            end


            for i in 1:size(finalproteinsred1[ii])[1]-1
                if finalproteinsred1[ii][i+1,1] - finalproteinsred1[ii][i,1] < 2.2
                    finalproteinsred1[ii][i+1,1] = finalproteinsred1[ii][i,1]
                end
            end

            finalproteinsred1[ii] = hcat(finalproteinsred1[ii], zeros(size(finalproteins1[ii])[1]))

            for i in 1:size(finalproteinsred1[ii])[1]
                finalproteinsred1[ii][i,5] = tempdfs[ii][Int64(finalproteinsred1[ii][i,3]),3]
            end

            order = sortperm(finalproteinsred1[ii][:,5])
            for i in 1:size(finalproteinsred1[ii])[2]
                finalproteinsred1[ii][:,i] = permute!(finalproteinsred1[ii][:,i], order)
            end

            order = sortperm(finalproteinsred1[ii][:,1])
            for i in 1:size(finalproteinsred1[ii])[2]
                finalproteinsred1[ii][:,i] = permute!(finalproteinsred1[ii][:,i], order)
            end

            finalproteinsred1[ii] = finalproteinsred1[ii][:, 1:end-1]
            finalproteinsred1[ii] = vcat(finalproteinsred1[ii], [0.0,0.0,0.0,1000000]')


            for i in 1:size(finalproteinsred1[ii])[1]-1
                if abs(finalproteinsred1[ii][i+1,1] - finalproteinsred1[ii][i,1]) < 2.2
                    @goto label1
                else
                    append!(finalproteins2[ii], [(finalproteinsred1[ii][i,:])])
                    @label label1
                end
            end

            finalproteinsred2[ii] = reduce(vcat, transpose(finalproteins2[ii]))

        end



        for ii in 1:length(tempdfs)
            order = sortperm(finalproteinsred2[ii][:,1])
            for i in 1:size(finalproteinsred2[ii])[2]
                finalproteinsred2[ii][:,i] = permute!(finalproteinsred2[ii][:,i], order)
            end

            finalproteinsred2[ii] =  hcat(finalproteinsred2[ii], zeros(size(finalproteinsred2[ii])[1]),zeros(size(finalproteinsred2[ii])[1]),zeros(size(finalproteinsred2[ii])[1]))
            for i in 1:size(finalproteinsred2[ii])[1]
                finalproteinsred2[ii][i,5] = tempdfs[ii][Int64(finalproteinsred2[ii][i,3]), 2] 
                finalproteinsred2[ii][i,6] = tempdfs[ii][Int64(finalproteinsred2[ii][i,3]), 8] 
                finalproteinsred2[ii][i,7] = tempdfs[ii][Int64(finalproteinsred2[ii][i,3]), 9] 
            end
            #get all masses and rt pero venom
        end

        vacio = []
        for i in 1:length(finalproteinsred2)
            for i2 in 1:size(finalproteinsred2[i])[1]
                append!(vacio, [finalproteinsred2[i][i2, :]])
            end
        end
        global FFinaldf = reduce(vcat, transpose(vacio))




#Manual data Matrix
InMatrix = Matrix(CSV.read("{Directory Manual Data}", DataFrame))



VarNames = InMatrix[:,1]
mznames = InMatrix[:,2]
InMatrix = InMatrix'[3:end, :]




joryproteins = [[] for i=1:length(tempdfs)]
joryproteinsred = [Array{Float64}(undef,0,0) for i=1:Int64(length(tempdfs))]
for i in 1:length(joryproteins)
    for ii in 1:size(InMatrix)[1]
        if InMatrix[ii,i+2] > 1
         append!(joryproteins[i], [[InMatrix[ii,1], InMatrix[ii,2], InMatrix[ii,i+2]] ])
        end
    end
end

for i in 1:length(joryproteins)
    joryproteinsred[i] = reduce(vcat, transpose(joryproteins[i]))
end

ploi = []
comparison = [[] for i=1:length(tempdfs)]
comparisonred= [Array{Float64}(undef,0,0) for i=1:Int64(length(tempdfs))]

for i in 1:length(joryproteins) 
    print(i)
    for ii in 1:size(joryproteinsred[i])[1]
        for iii in 1:size(finalproteinsred2[i])[1]
            if joryproteinsred[i][ii,1] > finalproteinsred2[i][iii,1] - 2 && joryproteinsred[i][ii,1] < finalproteinsred2[i][iii,1] + 2
                if joryproteinsred[i][ii,2] > finalproteinsred2[i][iii,4] - 1.1 && joryproteinsred[i][ii,2] < finalproteinsred2[i][iii,4] + 1.1
                    append!(comparison[i], [joryproteinsred[i][ii,:]])
                # finalproteinsred2[i][iii,1] = joryproteinsred[i][ii,1]
                    append!(ploi, [[joryproteinsred[i][ii,2], i,joryproteinsred[i][ii,3], joryproteinsred[i][ii,1]]])
                    joryproteinsred[i][ii,1] = 0
                end
            end
        end
    end
end

for i in 1:length(joryproteins) 
    print(i)
    for ii in 1:size(joryproteinsred[i])[1]
        for iii in 1:size(finalproteinsred2[i])[1]
            if joryproteinsred[i][ii,1] > finalproteinsred2[i][iii,1] - 2 && joryproteinsred[i][ii,1] < finalproteinsred2[i][iii,1] + 2
                    append!(comparison[i], [joryproteinsred[i][ii,:]])
                # finalproteinsred2[i][iii,1] = joryproteinsred[i][ii,1]
                    append!(ploi, [[joryproteinsred[i][ii,2], i,joryproteinsred[i][ii,3], joryproteinsred[i][ii,1]]])
                    joryproteinsred[i][ii,1] = 0
            end
        end
    end
end





for i in 1:length(joryproteins)
    for ii in 1:size(joryproteinsred[i])[1]
        for iii in 1:size(finalproteinsred2[i])[1]
            if joryproteinsred[i][ii,1] != 0
                if joryproteinsred[i][ii,2] > finalproteinsred2[i][iii,4] - 1.1 && joryproteinsred[i][ii,2] < finalproteinsred2[i][iii,4] + 1.1
                    append!(comparison[i], [joryproteinsred[i][ii,:]])
                 #   finalproteinsred2[i][iii,1] = joryproteinsred[i][ii,1]
                    append!(ploi, [[joryproteinsred[i][ii,2], i,joryproteinsred[i][ii,3], joryproteinsred[i][ii,1]]])
                    joryproteinsred[i][ii,1] = 0
                end
            end
        end
    end
end



for i in 1:length(joryproteins)
    for ii in 1:size(joryproteinsred[i])[1]
        for iii in 1:size(finalproteinsred2[i])[1]
            if joryproteinsred[i][ii,1] != 0
                z = joryproteinsred[i][ii,1]/finalproteinsred2[i][iii,1]
                if z - floor(z) > 0.995 && z - floor(1*(z)) < 1.0
                    append!(comparison[i], [joryproteinsred[i][ii,:]])
                   #    finalproteinsred2[i][iii,1] = joryproteinsred[i][ii,1]
                    append!(ploi, [[joryproteinsred[i][ii,2], i,joryproteinsred[i][ii,3], joryproteinsred[i][ii,1]]])
                    joryproteinsred[i][ii,1] = 0
                elseif  z - floor(z) > 0.0 && z - floor(1*(z)) < 0.005
                    append!(comparison[i], [joryproteinsred[i][ii,:]])
                   #    finalproteinsred2[i][iii,1] = finalproteinsred2[i][iii,1]
                    append!(ploi, [[joryproteinsred[i][ii,2], i,joryproteinsred[i][ii,3],joryproteinsred[i][ii,1]]])
                    joryproteinsred[i][ii,1] = 0
                elseif  z - floor(z) > 0.245 && z - floor(1*(z)) < 0.250
                    append!(comparison[i], [joryproteinsred[i][ii,:]])
                  #     finalproteinsred2[i][iii,1] = joryproteinsred[i][ii,1]
                    append!(ploi, [[joryproteinsred[i][ii,2], i,joryproteinsred[i][ii,3], joryproteinsred[i][ii,1]]])
                    joryproteinsred[i][ii,1] = 0
                elseif  z- floor(z) > 0.325 && z- floor(1*(z)) < 0.335
                    append!(comparison[i], [joryproteinsred[i][ii,:]])
                    #   finalproteinsred2[i][iii,1] = joryproteinsred[i][ii,2]
                    append!(ploi, [[joryproteinsred[i][ii,2], i,joryproteinsred[i][ii,3], joryproteinsred[i][ii,1]]])
                    joryproteinsred[i][ii,1] = 0
                elseif  z - floor(z) > 0.495 && z - floor(1*(z)) < 0.505
                    append!(comparison[i], [joryproteinsred[i][ii,:]])
                   #    finalproteinsred2[i][iii,1] = joryproteinsred[i][ii,1]
                    append!(ploi, [[joryproteinsred[i][ii,2], i,joryproteinsred[i][ii,3], joryproteinsred[i][ii,1]]])
                    joryproteinsred[i][ii,1] = 0
                elseif  z- floor(z) > 0.745 && z - floor(1*(z)) < 0.755
                    append!(comparison[i], [joryproteinsred[i][ii,:]])
                   #    finalproteinsred2[i][iii,1] = joryproteinsred[i][ii,1]
                    append!(ploi, [[joryproteinsred[i][ii,2], i,joryproteinsred[i][ii,3], joryproteinsred[i][ii,1]]])
                    joryproteinsred[i][ii,1] = 0
                elseif  z - floor(z) > 0.655 && z - floor(1*(z)) < 0.665
                    append!(comparison[i], [joryproteinsred[i][ii,:]])
                   #    finalproteinsred2[i][iii,1] = joryproteinsred[i][ii,1]
                    append!(ploi, [[joryproteinsred[i][ii,2], i,joryproteinsred[i][ii,3], joryproteinsred[i][ii,1]]])
                    joryproteinsred[i][ii,1] = 0
                end
            end
        end
    end
end








for i in 1:length(tempdfs)
    print(length(comparison[i]), " \n")
end



for i in 1:length(tempdfs)
    comparisonred[i] = reduce(vcat, transpose(comparison[i]))
end


ploi = reduce(vcat, transpose(ploi))

VarNames = sort(unique!(ploi[:,4]))
mznames = zeros(length(VarNames))
for i in 1:length(VarNames)
    for ii in 1:length(ploi[:,1])
        if VarNames[i] == ploi[:,4][ii]
            mznames[i] = ploi[:,1][ii]
        end
    end
end


z = zeros(length(tempdfs), length(unique!(ploi[:,4])))
h = sort(unique!(ploi[:,4]))
for i in 1:length(h)
    for ii in 1:size(ploi)[1]
        if ploi[ii,4] == h[i]
            if z[Int64(ploi[ii,2]),i] == 0.0
                z[Int64(ploi[ii,2]),i] = ploi[ii,3]
            else
                m = maximum([z[Int64(ploi[ii,2]),i], ploi[ii,3]])
                z[Int64(ploi[ii,2]),i] = m
            end
        end
    end
end




global VarNames = VarNames
global mznames = mznames
global InMatrix = z

NeekoShapesplitter = float(fill(1, size(InMatrix)))
for row in 1:size(InMatrix[:,1])[1]
    for col in 1:size(InMatrix[1,:])[1]
        if InMatrix[row,col] != 0
            NeekoShapesplitter[row,col] = 1
        else
            NeekoShapesplitter[row,col] = 0
        end
    end
end
FinalMatrixM = []
sums = []
for col in 1:length(NeekoShapesplitter[1,:])
    H = sum(NeekoShapesplitter[:,col])
    push!(sums, H)
end
varnums = []
global Finalmznames = []
global FinalVarNames = []
for number in 1:length(sums)
    if (sums[number]) >= Rep
        GoodVar = InMatrix[:,number]
        GoodNameVar = VarNames[number,:]
        GoodNameMz =  mznames[number, :]

            push!(FinalMatrixM, GoodVar)
            push!(FinalVarNames, GoodNameVar)
            push!(varnums, sums[number])
            push!(Finalmznames, GoodNameMz)
    end
end

placeholderM = reduce(vcat,transpose.(FinalMatrixM))'
placeholderM = placeholderM[1:size(InMatrix)[1], :]


#Create a real matrix taking into account the limitaitons of the mock matrix
L = ones((size(placeholderM)[1]), size(placeholderM)[2])
for row in 1:(size(placeholderM)[1])
    for col in 1:size(placeholderM)[2]
        L[row,col] = round.(placeholderM[row,col], digits=5)
    end
end

#Autoscale the matrix
global Matrix_as = Array{Float64, 2}(undef, size(L,1), size(L,2))
for column in 1:size(L,2)
    if sum(L[:,column]) > 0
        m = mean(L[:,column])
        s = std(L[:,column])
        Matrix_as[:,column]=((L[:,column].-m)./s)
    end
end

#Extract the autoscaled matrix, the mass and the m/z value from the proteins
global Model = Matrix_as

global  FinalMzNames= reduce(vcat, transpose.(Finalmznames))

global  FinalVarNames = reduce(vcat, transpose.(FinalVarNames))




global Matrix_as = Array{Float64, 2}(undef, size(L,1), size(L,2))
for column in 1:size(L,2)
    if sum(L[:,column]) > 0
        m = mean(L[:,column])
        s = std(L[:,column])
        Matrix_as[:,column]=((L[:,column].-m)./s)
    end
end


Modelc = Matrix_as
eigenva = eigvals(cov(Modelc))
eigenve = eigvecs(cov(Modelc))
zrev = Vector(sort(1:length(eigenva), rev=true))
ypre = permute!(sort(eigenva), zrev)
yvalues = cumsum(ypre)/sum(ypre)*100
nr_pc = 10
eg_vec_s = eigenve[:,zrev]
if nr_pc > size(eg_vec_s)[1]
    nr_pc = size(eg_vec_s)[1]
end
global LoadingsiJ = eg_vec_s[:, 1:nr_pc]
global Scoresi = Model*LoadingsiJ



Plots.plot([1:183],LoadingsiJ[:,1],color = "blue", label = "Manual extraction and processing")
Plots.plot!([1:183], LoadingsiL[:,1], color = "orange", legend = false ,label = "Automatic extraction and processing", xlabel = "Variable number", ylabel = "Weight of each variable in PC1")







d1 = 1
d2 = 2
d3 = 3

Plotly.plot([
    Plotly.scatter(x = Scoresi[1:5,d1], y = Scoresi[1:5,d2], z = Scoresi[1:5,d3], mode = "markers", name = "Pseudonaja Sp", type = "scatter3d"), 
    Plotly.scatter(x = Scoresi[6:10,d1], y = Scoresi[6:10,d2], z = Scoresi[6:10,d3], mode = "markers", name = "Pseudonaja NSp", type = "scatter3d"), 
])


ScoresiJ = Scoresi





    Plots.scatter(Scoresi[1:4,d1], Scoresi[1:4,d2], markershape =:square, color = "blue", label = "Pseudonaja textilis")
    Plots.scatter!(Scoresi[5:6,d1], Scoresi[5:6,d2],   markershape =:square, color = "lightblue", label = "Pseudonaja nuchalis")
    Plots.scatter!(Scoresi[7:7,d1], Scoresi[7:7,d2],  markershape =:square, color = "darkblue", label = "Pseudonaja modesta")
    Plots.scatter!(Scoresi[8:9,d1], Scoresi[8:9,d2],  markershape =:square, color = "purple", label = "Pseudonaja mengdeni")
    Plots.scatter!(Scoresi[10:10,d1], Scoresi[10:10,d2],  markershape =:square, color = "brown", label = "Pseudonaja ingrami")
    Plots.scatter!(Scoresi[11:11,d1], Scoresi[11:11,d2],  markershape =:square, color = "black", label = "Pseudonaja inframacula")
    Plots.scatter!(Scoresi[12:12,d1], Scoresi[12:12,d2],  markershape =:square, color = "darkgreen", label = "Pseudonaja guttata")
    Plots.scatter!(Scoresi[13:15,d1], Scoresi[13:15,d2],  markershape =:square, color = "green", label = "Pseudonaja aspidorhyncha")
    Plots.scatter!(Scoresi[16:17,d1], Scoresi[16:17,d2],  markershape =:square, color = "lightgreen", label = "Pseudonaja affinis", xlabel = "PC1 (13%)", ylabel = "PC2 (10%)"  ,legend= false)
    Plots.scatter!(Scoresi[18:20,d1], Scoresi[18:20,d2], markershape =:circle, color = "pink", label="Oxyuranus Microlep")
    Plots.scatter!(Scoresi[21:26,d1], Scoresi[21:26,d2], markershape =:circle, color = "red", label="Oxyuranus Scut")
    Plots.scatter!(Scoresi[27:29,d1], Scoresi[27:29,d2], markershape =:circle, color = "orange", label="Oxyuranus Scut Can")
    Plots.scatter!(Scoresi[30: length(InMatrix[:,1]),d1], Scoresi[30: length(InMatrix[:,1]),d2],markershape =:circle, color = "yellow", label ="Oxyuranus Temporalis", xlabel = "PC1 9%", ylabel = "PC2 8%"  ,legend=true) 






    Plots.scatter(Scoresi[1:3,d1], Scoresi[1:3,d2], markershape =:circle, color = "pink", label="Oxyuranus Microlep")
    Plots.scatter!(Scoresi[4:9,d1], Scoresi[4:9,d2], markershape =:circle, color = "red", label="Oxyuranus Scut")
    Plots.scatter!(Scoresi[10:12,d1], Scoresi[10:12,d2], markershape =:circle, color = "orange", label="Oxyuranus Scut Can")
    Plots.scatter!(Scoresi[13: length(InMatrix[:,1]),d1], Scoresi[13: length(InMatrix[:,1]),d2],markershape =:circle, color = "yellow", label ="Oxyuranus Temporalis", xlabel = "PC1 (20%)", ylabel = "PC2 (15%)"  ,legend=true) 
